<!DOCTYPE html>
<html>
<head>
	<meta charset="utf-8">
	<meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
	<title>Bootstrap flex</title>

	<!-- Bootstrap CSS -->
	<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/css/bootstrap.min.css" integrity="sha384-xOolHFLEh07PJGoPkLv1IbcEPTNtaed2xpHsD9ESMhqIYd0nLMwNLD69Npy4HI+N" crossorigin="anonymous">


	<!-- <link rel="stylesheet" href="./index.css"> -->
</head>
<body>
	<div class="container-fluid text-center">
		<h1>Bootstrap Flex</h1>
		<p>Use the d-flex to create a flex container and transform direct children into a flex items.</p>

		<h2>Centering Elements</h2>
		<div style="height: 500px;" class="bg-secondary p-3 d-flex justify-content-center align-items-center flex-column-reverse">
			<!-- d-flex will change all of the child div elements into flex items. the flex items will only occupy the space enough for the element's content -->
			<div class="h-25 p-3 bg-success">Flex Item A</div>
			<div class="h-25 p-3 bg-warning">Flex Item B</div>
			<div class="h-25 p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row</h2>
		<div class="bg-dark d-flex flex-row p-3">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Flex Row Reverse</h2>
		<div class="bg-dark d-flex flex-row-reverse p-3">
			<div class="p-3 bg-success">Flex Item A</div>
			<div class="p-3 bg-warning">Flex Item B</div>
			<div class="p-3 bg-danger">Flex Item C</div>
		</div>

		<h2>Creating Space Between Elements</h2>
		<!-- d-md-flex will apply a flex value to the display property on a "medium" size and larger -->
		<div class="bg-dark p-3 d-md-flex justify-content-around">
			<!-- justify-content-around centers elements horizontally, while creating space between elements and the border of its parent container -->
			<div class="p-3 bg-success col-md-2">Card A</div>
			<div class="p-3 bg-warning col-md-2">Card B</div>
			<div class="p-3 bg-danger col-md-2">Card C</div>
		</div>

		<h2>Flexbox With Margin</h2>
		<div class="bg-dark p-3 d-flex">
			<!-- mr-auto class will occupy the remaining width of its parent container pushing all the other elements -->
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="p-3 bg-warning m-auto">Flex Item B</div>
			<div class="p-3 bg-danger m-auto">Flex Item C</div>
			<div class="p-3 bg-primary ml-auto">Flex Item D</div>
		</div>

		<h2>Nested Flex Elements</h2>
		<div class="bg-dark p-3 d-block d-md-flex">
			<!-- d-classes will only apply to its child elements, and not to its grandchild elements -->
			<div class="p-3 bg-success mr-auto">Flex Item A</div>
			<div class="w-50 d-block d-md-flex justify-content-between">
				<!-- Unlike the "justify-content-around", the "justify-content-between" creates space between elements but removes the padding leftmost and reghtmost of its parent element -->
				<div class="p-3 bg-warning">Flex Item B</div>
				<div class="p-3 bg-danger">Flex Item C</div>
				<div class="p-3 bg-info">Flex Item D</div>
			</div>

		</div>
	</div>

	<!-- JS Depedencies -->
	<script src="https://cdn.jsdelivr.net/npm/jquery@3.5.1/dist/jquery.slim.min.js" integrity="sha384-DfXdz2htPH0lsSSs5nCTpuj/zy4C+OGpamoFVy38MVBnE+IbbVYUew+OrCXaRkfj" crossorigin="anonymous"></script>
	<script src="https://cdn.jsdelivr.net/npm/bootstrap@4.6.2/dist/js/bootstrap.bundle.min.js" integrity="sha384-Fy6S3B9q64WdZWQUiU+q4/2Lc9npb8tCaSX9FK7E8HnRr0Jz8D6OP9dO5Vg3Q9ct" crossorigin="anonymous"></script>

</body>
</html>